; Color Test Program
; Charles Wieland, 7/21/1998
; junkosoft.org

	processor 6502
	include vcs.h

	ORG $F000

FRAME0   = $80
FRAME1   = $81
FRAME2	 = $82
CURCOLP0 = $83
CURCOLBK = $84
TEMP     = $85
LOCP0    = $86
LOCP1    = $87

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00
	
clrstk  STA $00,X
	DEX
	BNE clrstk
	LDA #$00
	STA CURCOLP0
	LDA #$1E
	STA FRAME0
	STA FRAME1
	STA FRAME2
	LDA #$07
	STA NUSIZ0
	STA NUSIZ1

	LDX #$5C
topfrm  STA WSYNC
	DEX
	BNE topfrm
	LDX #$05
delay	DEX
	BNE delay
	NOP
	STA RESP0
	LDX #$02
delay2	DEX
	BNE delay2
	STA RESP1
	STA WSYNC
	LDX #$63
btmfrm  STA WSYNC
	DEX
	BNE btmfrm

figpos	LDA CURCOLP0
	AND #$0F
	TAX
	LDA #$00
	CPX #$00
onesdig	BEQ done0
	ADC #$08
	DEX
	BNE onesdig
	TAX
	DEX
done0	STX LOCP0
	LDA CURCOLP0
	AND #$F0
	LSR
	LSR
	LSR
	LSR
	TAX
	LDA #$00
	CPX #$00
tensdig	BEQ done1
	ADC #$08
	DEX
	BNE tensdig
	TAX
	DEX
done1	STX LOCP1

vblank	LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn

dodraw	LDA #$00
	STA WSYNC
	STA VBLANK
	LDA CURCOLP0
	STA COLUP0
	STA COLUP1
	LDA CURCOLBK
	STA COLUBK
	LDX #$40
drawtop STA WSYNC
	DEX
	BNE drawtop
	LDX #$08
drawmid	STX TEMP
	LDX LOCP1
	LDA sprdata,X
	STA GRP0
	INC LOCP1
	LDX LOCP0
	LDA sprdata,X
	STA GRP1
	INC LOCP0
	LDX TEMP
	LDY #$08
doline	STA WSYNC
	DEY
	BNE doline
	DEX
	BNE drawmid
	LDA #$00
	STA GRP0
	STA GRP1
	LDX #$40
drawbot	STA WSYNC
	DEX
	BNE drawbot
	LDA #$00
	STA COLUP0
	STA COLUP1
	STA COLUBK
	STA WSYNC
	STA VBLANK
	
oscan	LDA SWCHA
	AND #$F0
	CMP #$E0
	BEQ up
	CMP #$D0
	BEQ down
	CMP #$B0
	BEQ left
	CMP #$70
	BEQ right
	JMP chkrst

up	DEC FRAME0
	BNE chkrst

upp0	LDA #$1E
	STA FRAME0
	INC CURCOLP0
	INC CURCOLP0
	JMP chkrst

down	DEC FRAME0
	BNE chkrst

downp0	LDA #$1E
	STA FRAME0
	DEC CURCOLP0
	DEC CURCOLP0
	BNE chkrst

right	DEC FRAME1
	BNE chkrst

upbk	LDA #$1E
	STA FRAME1
	INC CURCOLBK
	INC CURCOLBK
	JMP chkrst

left	DEC FRAME1
	BNE chkrst

downbk	LDA #$1E
	STA FRAME1
	DEC CURCOLBK
	DEC CURCOLBK

chkrst	LDA SWCHB
	AND #$03
	CMP #$02
	BEQ reset
	CMP #$01
	BEQ select
	JMP over

reset	LDA #$00
	STA CURCOLP0
	STA CURCOLBK
	JMP over

select	DEC FRAME2
	BNE over

up10	LDA #$1E
	STA FRAME2
	LDA CURCOLP0
	ADC #$0F
	STA CURCOLP0

over	LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP figpos

sprdata .byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11000011
        .byte %11000011
        .byte %11000011
        .byte %11111111
        .byte %11111111

	.byte %00011000
        .byte %00011000
        .byte %00011000
        .byte %00011000
        .byte %00011000
        .byte %00011000
        .byte %00011000
        .byte %00011000

	.byte %11111111
        .byte %11111111
        .byte %00000011
        .byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11111111
        .byte %11111111

	.byte %11111111
        .byte %11111111
        .byte %00000011
        .byte %11111111
        .byte %11111111
        .byte %00000011
        .byte %11111111
        .byte %11111111

	.byte %11000011
        .byte %11000011
        .byte %11000011
        .byte %11111111
        .byte %11111111
        .byte %00000011
        .byte %00000011
        .byte %00000011

	.byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11111111
        .byte %11111111
        .byte %00000011
        .byte %11111111
        .byte %11111111

	.byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11111111
        .byte %11111111

	.byte %11111111
        .byte %11111111
        .byte %00000011
        .byte %00000011
        .byte %00000011
        .byte %00000011
        .byte %00000011
        .byte %00000011

	.byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11111111
        .byte %11111111

	.byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11111111
        .byte %11111111
        .byte %00000011
        .byte %11111111
        .byte %11111111

        .byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11000011
        .byte %11000011

        .byte %11111110
        .byte %11111111
        .byte %11000011
        .byte %11111111
        .byte %11111111
        .byte %11000011
        .byte %11111111
        .byte %11111110

        .byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11000000
        .byte %11000000
        .byte %11000000
        .byte %11111111
        .byte %11111111

        .byte %11111110
        .byte %11111111
        .byte %11000011
        .byte %11000011
        .byte %11000011
        .byte %11000011
        .byte %11111111
        .byte %11111110

        .byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11111111
        .byte %11111111

        .byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11111111
        .byte %11111111
        .byte %11000000
        .byte %11000000
        .byte %11000000

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
        .word Start
