; Dodge Ball with one player, ball, and collision
; Charles Wieland, 3/18/1998
; junkosoft.org

	processor 6502
	include vcs.h

	org $F000

CURCOLOR = $80	; Used to draw shaded playfield
POS10	 = $81	; Player 0 top position
POS20	 = $82	; Player 0 bottom postion
POS11	 = $83	; Player 1 top position
POS21	 = $84	; Player 1 bottom position
BLHPOS   = $85	; Horizontal Position of Ball

; Main Program and Initialization

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STA SWBCNT
        STA SWACNT
	LDA #$19
	STA CTRLPF
	LDA #$30
	STA POS10
	STA POS11
	STA POS20
	STA POS21
	LDA #$0C
	STA AUDF0
	STA AUDC0

	LDX #$5C
topfrm  STA WSYNC
	DEX
	BNE topfrm
	LDX #$03
delay   DEX
	BNE delay
	NOP
	STA RESP0
	STA RESP1
	LDX #$07
delay2	DEX
	BNE delay2
	NOP
	STA RESBL
	STA WSYNC
	LDX #$63
btmfrm  STA WSYNC
	DEX
	BNE btmfrm
	
; Vertical Blank Handler

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC
	STA HMOVE
	LDA CXP0FB
	AND #$40
	BNE p0bl
	LDA #$00
	STA CXCLR
	STA AUDV0
	JMP vars

p0bl    LDA #$0F
	STA AUDV0
	STA CXCLR

; Color Setup Routine
 
vars	LDA SWCHB
	AND #$01
	BEQ Start
	LDA SWCHB
	AND #$08
	BEQ bw

color	LDA #$80
	STA CURCOLOR
	LDA #$54
	STA COLUP0
	LDA #$C2
	STA COLUP1
	JMP draw

bw	LDA #$00
	STA CURCOLOR
	LDA #$06
	STA COLUP0
	LDA #$02
	STA COLUP1
	
; Screen Draw routine

draw	LDA INTIM
	BNE draw
	STA WSYNC
	STA VBLANK
	LDA #$00
	STA PF0
	STA PF1
	STA PF2
	LDX #$1C
drawtop STA WSYNC
	DEX
	BNE drawtop
	LDX #$10
	LDA #$FF
	STA PF0
	STA PF1
	STA PF2
	LDY CURCOLOR
topcol  STY COLUPF
	STA WSYNC
	INY
	DEX
	BNE topcol
	LDA #$30
	STA PF0
	LDA #$00
	STA PF1
	STA PF2
	STA GRP0
	STA GRP1
	LDX POS10
topspr	STA WSYNC
	DEX
	BNE topspr
	LDA #$FF
	STA ENABL
	LDA #$30
	STA HMBL
	LDX #$07
drawspr	DEX
	LDA p0data,X
	STA GRP0
	STA WSYNC
	TXA
	BNE drawspr
	STX ENABL
	STX GRP0
	LDX POS20
botspr	STA WSYNC
	DEX
	BNE botspr
	LDA #$FF
	STA PF0
	STA PF1
	STA PF2
	LDX #$10
botcol  DEY
	STY COLUPF
	STA WSYNC
	DEX
	BNE botcol
	LDA #$00
	STA PF0
	STA PF1
	STA PF2
	LDX #$1C
drawbot STA WSYNC
	DEX
	BNE drawbot
clear   LDA #$02
	STA WSYNC
	STA VBLANK
	JMP oscan

; Overscan and Joystick routine

oscan   LDA SWCHA
	AND #$F0
	CMP #$E0
	BEQ up0
	CMP #$D0
	BEQ down0
	JMP over

up0	LDA POS10
	CMP #$01
	BEQ over
	DEC POS10
	INC POS20
	JMP over

down0	LDA POS20
	CMP #$01
	BEQ over
	INC POS10
	DEC POS20

over	LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

p0data	.byte $42,$42,$7E,$BD,$BD,$FF,$18,$18
	.byte $3C,$42,$5A,$FF,$FF,$5B,$7E,$3C
bdata

	org $FFFC
	.word Start
	.word Start     
