; Atari Logo Playfield Demo with color scroll!
; Charles Wieland, 2/28/1998
; Junkosoft.org

; Portions from
; Nick Benmesa's 'How to draw a playfield'
; and Chris Cracknell's Playfield demo

	PROCESSOR 6502

CURCOLOR = $80

	INCLUDE VCS.H
	ORG $F000

start   SEI
	CLD
	LDX #$FF
	TXS
        LDA #$00
clrstk  STA $00,X
	DEX
	BNE clrstk
        LDA #$0C
        STA AUDF0
        STA AUDC0
        LDA #$00
        STA AUDV0
	STA CURCOLOR
main    JSR vertb
	JSR vars
	JSR drawscr
	JSR oscan
	JMP main

vertb   LDX #$00
	LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA CXCLR
	STA WSYNC
	STA VSYNC
	RTS

vars	LDA #$00
	STA COLUBK
	LDA #$01
	STA CTRLPF
	LDA SWCHB
	AND #$08 ; Check for B/W - Color Switch
	BEQ bw
	LDA SWCHB
	AND #$C0 ; Check P0 and P1 a/b switch
	BEQ inv
	LDA SWCHB
        AND #$40 ; Check P0 a/b switch
	BEQ const
	LDA SWCHB
	AND #$80 ; Check P1 a/b switch
	BEQ invscr
	JMP scroll
const	LDA #$32
	STA COLUPF
	RTS
bw      LDA #$04
	STA COLUPF
	RTS
scroll  INC CURCOLOR
	LDA CURCOLOR
	STA COLUPF
	RTS
invscr  INC CURCOLOR
	LDA CURCOLOR
	STA COLUBK
	LDA #$00
	STA COLUPF
	RTS	
inv	LDA #$00
	STA COLUPF
	LDA #$32
	STA COLUBK
	RTS

drawscr LDA INTIM
	BNE drawscr
	STA WSYNC
	STA VBLANK
	LDY #$08 ; 08 scanlines per row
	LDX #$17 ; 24 blocks per row
loadpf  LDA pfdata0,X
	STA PF0
	LDA pfdata1,X
	STA PF1
	LDA pfdata2,X
	STA PF2
doline  DEY
	STA WSYNC
	BNE doline
	TXA
	BEQ clear
	DEX
	LDY #$08
	JMP loadpf
clear   LDA #$02
	STA WSYNC
	STA VBLANK
	LDX PF0
	LDX PF1
	LDX PF2
	RTS
		
oscan   LDX #$1E
doscan  STA WSYNC
	DEX
        BNE doscan
        RTS

	ORG $FF00
pfdata0 .byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	.byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	.byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
pfdata1 .byte $00,$00,$00,$06,$03,$01,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
pfdata2 .byte $00,$00,$00,$C0,$C0,$C1,$C3,$C6
	.byte $C6,$CC,$CC,$D8,$D8,$D8,$D8,$D8
	.byte $D8,$D8,$D8,$D8,$00,$00,$00,$00

	ORG $FFFC
	.word start
	.word start
