; Atari Logo Playfield Demo (PAL version)
; Charles Wieland, 1/14/1998 (modified for PAL 8/24/98)
; Junkosoft.org

; Portions from
; Nick Benmesa's 'How to draw a playfield'
; and Chris Cracknell's Playfield demo

	PROCESSOR 6502

	INCLUDE VCS.H
	ORG $F000

start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00
clrstk  STA $00,X
	DEX
	BNE clrstk
main    JSR vertb
	JSR vars
	JSR drawscr
	JSR oscan
	JMP main

vertb   LDX #$00
	LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$3A
	STA TIM64T
	LDA #$00
	STA CXCLR
	STA WSYNC
	STA VSYNC
	RTS

vars    LDA #$00
	STA COLUBK
	LDA #$01
	STA CTRLPF
	LDA SWCHB
	AND #$08 ; Check for B/W - Color Switch
	BEQ bw
	LDA #$32
	STA COLUPF
	RTS
bw      LDA #$04
	STA COLUPF
	RTS

drawscr LDA INTIM
	BNE drawscr
	STA WSYNC
	STA VBLANK
	LDX #$17 ; 24 blocks per row
loadpf  LDY #$09 ; 09 scanlines per row
	LDA pfdata0,X
	STA PF0
	LDA pfdata1,X
	STA PF1
	LDA pfdata2,X
	STA PF2
doline  STA WSYNC
	DEY
	BNE doline
	DEX
	BNE loadpf
	LDY #$0C
finish	STA WSYNC
	DEY
	BNE finish
clear   LDA #$02
	STA WSYNC
	STA VBLANK
	LDX PF0
	LDX PF1
	LDX PF2
	RTS
		
oscan   LDX #$24 ; 36 scanlines here
doscan  STA WSYNC
	DEX
	; do stuff here
	BNE doscan
	RTS
	
	ORG $F7FC
	.word start
	.word start

	ORG $FF00
pfdata0 .byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	.byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	.byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
pfdata1 .byte $00,$00,$00,$06,$03,$01,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
pfdata2 .byte $00,$00,$00,$C0,$C0,$C1,$C3,$C6
	.byte $C6,$CC,$CC,$D8,$D8,$D8,$D8,$D8
	.byte $D8,$D8,$D8,$D8,$00,$00,$00,$00

	ORG $FFFC
	.word start
	.word start
