; Vertical Scrolling Maze Game
; Charles Wieland, 4/15/1998
; junkosoft.org

	processor 6502
	include vcs.h

FRAMECNT = $80
LEVEL    = $81
VERTPOS  = $82
DEAD     = $83

	org $F000

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STX PF1
	STX PF2
	STX LEVEL
	STX DEAD
	LDA #$17
	STA VERTPOS
	LDA #$14
	STA FRAMECNT
	LDA #$01
	STA CTRLPF
	
	LDX #$5C
topfrm  STA WSYNC
	DEX
	BNE topfrm
	LDX #$90
delay   DEX
	BNE delay
	STA RESP0
	NOP
	STA RESP1
	STA WSYNC
	LDX #$63
btmfrm  STA WSYNC
	DEX
	BNE btmfrm

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC
	LDA DEAD
	BNE vars
	STA HMOVE

chkcol  LDA CXP0FB
	AND #$80
	BEQ vars

p0hit   LDA #$01
	STA DEAD
	
vars    LDA #$00
	STA CXCLR
	LDA SWCHB
	AND #$01
	BEQ reset
	LDA DEAD
	BNE chkbut
	JMP notdead

chkbut  LDA INPT4
	BPL reset
	JMP draw
	
notdead DEC FRAMECNT
	BEQ incvert
	JMP draw

reset   LDA #$17
	STA VERTPOS
	LDA #$14
	STA FRAMECNT
	LDA #$00
	STA DEAD
	JMP draw

incvert LDA #$14
	STA FRAMECNT
	INC VERTPOS
	LDA VERTPOS
	CMP #$8F
	BEQ vertres
	JMP draw

vertres LDA #$8E
	STA VERTPOS
	INC LEVEL

draw    LDA SWCHB
	AND #$08
	BEQ bw

color   LDA #$34
	STA COLUBK
	LDA #$1A        
	STA COLUP0      
	LDA #$64
	STA COLUPF
	JMP doscrn

bw      LDA #$00
	STA COLUBK
	LDA #$0D
	STA COLUP0
	LDA #$08
	STA COLUPF

doscrn  LDA INTIM
	BNE doscrn
	STA WSYNC
	STA VBLANK
	LDY VERTPOS
	LDX #$16
drawtop CPY #$78
	BPL clrpf
	LDA pfdata0,Y
	STA PF0
	LDA pfdata1,Y
	STA PF1
	LDA pfdata2,Y
	STA PF2
	JMP dodraw
clrpf   LDA #$00
	STA PF0
	STA PF1
	STA PF2
dodraw  STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	DEY
	DEX
	BNE drawtop
	CPY #$78
	BPL loadspr
	LDA pfdata0,Y
	STA PF0
	LDA pfdata1,Y
	STA PF1
	LDA pfdata2,Y
	STA PF2
loadspr LDA sprdata,X
	STA GRP0
	STA WSYNC
	INX
	CPX #$08
	BNE loadspr
bottom  LDA #$00
	STA GRP0
	CPY #$78
	BPL drawbot
	DEY
	LDA pfdata0,Y
	STA PF0
	LDA pfdata1,Y
	STA PF1
	LDA pfdata2,Y
	STA PF2
drawbot STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	LDA #$00
	STA PF0
	STA PF1
	STA PF2
clear   STA WSYNC
	STA VBLANK

oscan   LDA SWCHA
	AND #$F0
	CMP #$B0
	BEQ left0
	CMP #$70
	BEQ right0
	LDX #$00
	STX HMP0
	CMP #$E0
	BEQ up0
	JMP done

left0   LDA #$10
	STA HMP0
	JMP done

right0  LDA #$F0
	STA HMP0
	JMP done

up0     LDA #$01
	STA FRAMECNT

done    LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

sprdata .byte $00,$00,$00,$18,$18,$00,$00,$00
	.byte $18,$18,$7E,$5A,$5A,$3C,$42,$42

pfdata0 .byte $00,$00,$00,$00,$00,$80,$80,$80
	.byte $80,$80,$80,$80,$80,$80,$80,$80
	.byte $80,$80,$80,$80,$80,$80,$80,$F0
	.byte $10,$10,$10,$10,$F0,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$F0
	.byte $00,$00,$00,$00,$00,$80,$40,$20
	.byte $20,$20,$20,$20,$20,$20,$20,$20
	.byte $E0,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$F0,$80,$80,$80,$80,$80
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$B0,$20,$20,$20,$20,$30,$00
	.byte $20,$20,$E0,$00,$00,$F0,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$80,$40,$20
	.byte $90,$20,$40,$70,$10,$10,$10,$10

pfdata1 .byte $00,$00,$00,$00,$00,$48,$78,$00
	.byte $3F,$20,$23,$22,$22,$22,$22,$22
	.byte $22,$22,$22,$22,$22,$22,$22,$22
	.byte $22,$22,$22,$22,$E2,$20,$22,$22
	.byte $22,$23,$02,$22,$3E,$20,$00,$FF
	.byte $01,$01,$7F,$00,$10,$20,$7D,$84
	.byte $84,$87,$84,$84,$84,$FC,$00,$00
	.byte $F3,$12,$12,$12,$12,$12,$02,$12
	.byte $12,$12,$1E,$02,$02,$03,$00,$FF
	.byte $81,$80,$83,$85,$89,$91,$A1,$FF
	.byte $20,$E3,$02,$FE,$80,$80,$80,$80
	.byte $80,$FB,$92,$00,$10,$90,$90,$9F
	.byte $90,$90,$88,$44,$23,$10,$09,$04
	.byte $09,$12,$24,$48,$90,$20,$40,$80
	.byte $07,$FC,$01,$3F,$00,$00,$00,$00

pfdata2 .byte $00,$00,$00,$00,$00,$91,$91,$91
	.byte $91,$90,$9F,$80,$C0,$48,$48,$CC
	.byte $04,$04,$04,$84,$84,$84,$84,$84
	.byte $84,$84,$80,$84,$84,$BC,$84,$84
	.byte $84,$87,$80,$80,$BF,$90,$90,$9C
	.byte $84,$84,$F4,$14,$14,$14,$17,$F4
	.byte $14,$17,$10,$10,$1E,$02,$00,$00
	.byte $0F,$08,$08,$08,$08,$08,$B8,$00
	.byte $F8,$08,$08,$08,$08,$0F,$08,$08
	.byte $08,$08,$F8,$00,$00,$00,$00,$7E
	.byte $40,$77,$14,$14,$14,$04,$14,$10
	.byte $14,$17,$10,$11,$11,$F1,$11,$11
	.byte $00,$1F,$00,$00,$0F,$08,$09,$09
	.byte $09,$09,$39,$21,$2F,$28,$28,$28
	.byte $2F,$20,$3F,$00,$00,$00,$00,$00

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
 
