; Atari 2600 Demo (Noize Maker)
; Charles Wieland
; June 19, 1997
; Compiles with DASM 2.02
        processor 6502
        include vcs.h

        org $F000

;variables
STICKPOS = $80          ; Joystick Postition

Start           ; Setup Everything
        SEI             ; Disable Interrupts
        CLD             ; Clear Decimal Mode
        LDX #$FF        ; Put FF in X
        TXS             ; Transfer X to stack pointer
        LDA #0          ; Put 00 in Accumlator
B1      STA 0,X         ; Store A in memory location X
        DEX             ; Decrement X
        BNE B1          ; Branch to B1 until X = 00
        STX SWACNT      ; Initialize Port A for input
        LDX #$0C        ; Put 0C in X
        STX AUDC0       ; Set Distortion 0 to 0C (pure tone)
        LDX #$00        ; Put 00 in X
        STX AUDV0       ; Set Volume 0 to 00

MainLoop        ; Main Program Loop
        LDA SWCHA       ; Read Port A input
        STA STICKPOS    ; Store A in STICKPOS
        LDA #$90        ; Put 90 in A
        AND STICKPOS    ; Check for up & right
        BEQ UpRight     ; if so, branch to UpRight
        LDA #$A0        ; Put A0 in A
        AND STICKPOS    ; Check for down & right
        BEQ DownRight   ; if so, branch to DownRight
        LDA #$50        ; Put 50 in A
        AND STICKPOS    ; Check for up & left
        BEQ UpLeft      ; if so, branch to UpLeft
        LDA #$60        ; Put 60 in A
        AND STICKPOS    ; Check for down & left
        BEQ DownLeft    ; if so, branch to DownLeft
        LDA #$10        ; Put 10 in A
        AND STICKPOS    ; Check for up
        BEQ Up          ; if so, branch to Up
        LDA #$20        ; Put 20 in A
        AND STICKPOS    ; Check for down
        BEQ Down        ; if so, branch to Down
        LDA #$40        ; Put 40 in A
        AND STICKPOS    ; Check for left
        BEQ Left        ; if so, branch to Left
        LDA #$80        ; Put 80 in A
        AND STICKPOS    ; Check for right
        BEQ Right       ; if so, branch to Right
        LDY #$00        ; Put 00 in Y
        STY AUDV0       ; Set Volume 0 to 00
        JMP MainLoop    ; Jump to MainLoop

Up
        LDX #$03        ; Load X with 03
        JMP Play        ; Jump to subroutine Play
        
UpRight
        LDX #$07        ; Load X with 07
        JMP Play        ; Jump to subroutine Play
        
Right
        LDX #$0B        ; Load X with 0B
        JMP Play        ; Jump to subroutine Play
        
DownRight
        LDX #$0F        ; Load X with 0F
        JMP Play        ; Jump to subroutine Play
        
Down
        LDX #$13        ; Load X with 13
        JMP Play        ; Jump to subroutine Play
        
DownLeft
        LDX #$17        ; Load X with 17
        JMP Play        ; Jump to subroutine Play
        
Left
        LDX #$1B        ; Load X with 1B
        JMP Play        ; Jump to subroutine Play
        
UpLeft
        LDX #$1F        ; Load X with 1F
        JMP Play        ; Jump to subroutine Play
        
Play    
        STX AUDF0       ; Set Frequency 0 to X
        LDX #$05        ; Put 05 in X
        STX AUDV0       ; Set Volume 0 to X
        JMP MainLoop    ; Jump to MainLoop

        ORG $F7FA
        ; Boot up address
        dc.w Start
        dc.w Start
        dc.w Start
