; Scrolling Playfield Demo
; Charles Wieland, 4/6/1998
; junkosoft.org

	processor 6502
	include vcs.h

	org $F000

CURDIR = $80
DISPOS = $81
FRAME  = $82

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STX PF0
	STX PF1
	STX CURDIR
	LDA #$01
	STA CTRLPF
	LDA #$34
	STA COLUPF

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC
	STA HMOVE
	LDA #$00
	STA CXCLR

vars	LDA CURDIR
	BEQ down

up	LDA DISPOS
	BEQ uplim
	DEC DISPOS
	JMP draw

uplim	LDA #$00
	STA CURDIR
	INC DISPOS
	JMP draw

down	LDA DISPOS
	CMP #$18
	BEQ downlim
	INC DISPOS
	JMP draw

downlim	LDA #$01
	STA CURDIR
	DEC DISPOS

draw	LDA INTIM
	BNE draw
	STA WSYNC
	STA VBLANK
	LDX #$18
	LDY DISPOS
drawscr	LDA pfdata,Y
	STA PF2
	INY	
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	DEX
	BNE drawscr
	STA WSYNC
	STA VBLANK

oscan	LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

pfdata	.byte $00,$41,$41,$7F,$40,$40,$00,$7F
	.byte $01,$01,$7F,$00,$7F,$30,$18,$7F
	.byte $00,$7F,$18,$24,$43,$00,$7F,$41
	.byte $41,$7F,$00,$79,$49,$49,$4F,$00
	.byte $7F,$41,$41,$7F,$00,$7F,$48,$48
	.byte $40,$00,$40,$40,$7F,$40,$40,$00

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start