; Scrolling Playfield Demo
; Charles Wieland, 4/8/1998
; junkosoft.org

	processor 6502
	include vcs.h

	org $F000

CURDIR  = $80 ; Up or down
DISPOS  = $81 ; Current top position of screen
FRAME   = $82 ; Frame delay
TEMPFRM	= $83 ; 

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STX PF0
	STX PF1
	STX CURDIR
	STX CTRLPF
	LDA #$08
	STA FRAME

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC
	STA HMOVE
	LDA #$00
	STA CXCLR

	LDA SWCHB
	AND #$08
	BEQ bw

color   LDA #$34
	STA COLUPF
	JMP vars

bw      LDA #$08
	STA COLUPF

vars	DEC FRAME
	LDA FRAME
	BNE draw
	LDA #$08
	STA FRAME 
	LDA CURDIR
	BEQ down

up      LDA DISPOS
	BEQ uplim
	DEC DISPOS
	JMP draw

uplim   LDA #$00
	STA CURDIR
	INC DISPOS
	JMP draw

down    LDA DISPOS
	CMP #$20
	BEQ downlim
	INC DISPOS
	JMP draw

downlim LDA #$01
	STA CURDIR
	DEC DISPOS

draw    LDA INTIM
	BNE draw
	STA WSYNC
	STA VBLANK
	LDX #$18
	LDY DISPOS
drawscr	STX TEMPFRM
	LDX #$08
doline	STA WSYNC
	LDA pfdata,Y	;4
	STA PF2		;3
	LDA pfdata,Y	;4
	LDA pfdata,Y	;4
	LDA pfdata,Y	;4
	LDA pfdata,Y	;4
	LDA pfdata,Y	;4
	LDA #$00	;2
	NOP		;2
	NOP		;2
	NOP		;2
	NOP		;2
	NOP		;2
	NOP		;2
	NOP		;2
	NOP		;2
	NOP		;2
	DEX
	STA PF2
	BNE doline
	INY
	DEC TEMPFRM
	LDX TEMPFRM
	BNE drawscr
	STA WSYNC
	STA VBLANK

oscan   LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

pfdata  .byte $00,$00,$00,$00,$00,$41,$41,$7F
	.byte $40,$40,$00,$7F,$01,$01,$7F,$00
	.byte $7F,$30,$18,$7F,$00,$7F,$18,$24
	.byte $43,$00,$7F,$41,$41,$7F,$00,$79
	.byte $49,$49,$4F,$00,$7F,$41,$41,$7F
	.byte $00,$7F,$48,$48,$40,$00,$40,$40
	.byte $7F,$40,$40,$00,$00,$00,$00,$00

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
