; Sprite Demo / Test with rewritten draw function
; Charles Wieland, 8/26/1998
; junkosoft.org

	processor 6502
	include vcs.h

	org $F000

TOPPOS	= $80 ; Number of lines at top
BOTPOS	= $81 ; Number of lines at bottom
SPRSIZE	= $82 ; Size of sprite in scanlines

; Main Program and Initialization

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	LDA #$08
	STA SPRSIZE     ; Size of sprite (8 scanlines)
	LDA #$5C        ; Initial Sprite location
	STA TOPPOS
	STA BOTPOS
	LDA #$00
	STA COLUPF      ; Black playfield color

	LDX #$5C
topfrm  STA WSYNC
	DEX
	BNE topfrm
	LDX #$90
delay   DEX
	BNE delay
	NOP
	STA RESP0
	STA WSYNC
	LDX #$63
btmfrm  STA WSYNC
	DEX
	BNE btmfrm

; Vertical Blank Handler

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	STA HMOVE
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA CXCLR       
	STA WSYNC
	STA VSYNC

; Color Setup Routine

vars    LDA SWCHB
	AND #$08 ; Check for B/W - Color Switch
	BEQ bw

color   LDX #$32
	STX COLUP0
	JMP draw

bw      LDX #$08
	STX COLUP0

; Screen Draw routine

draw    LDA INTIM
	BNE draw
	STA WSYNC
	STA VBLANK
	LDX TOPPOS
drawtop STA WSYNC
	DEX
	BNE drawtop
	LDX SPRSIZE
drawspr DEX
	LDA ship,X
	STA GRP0
	LDA colors,X
	STA COLUP0
	STA WSYNC
	TXA
	BNE drawspr
	STX GRP0
	LDX BOTPOS
drawbot STA WSYNC
	DEX
	BNE drawbot

; Overscan and Joystick routine

oscan   LDA SWCHA
	CMP #$BF
	BEQ left
	CMP #$7F
	BEQ right

	LDA #$00
	STA HMP0

	LDA SWCHA
	CMP #$EF
	BEQ up
	CMP #$DF
	BEQ down
	JMP over

up      LDA TOPPOS
	CMP #$01
	BEQ over
	DEC TOPPOS
	INC BOTPOS
	JMP over

down    LDA BOTPOS
	CMP #$01
	BEQ over
	DEC BOTPOS
	INC TOPPOS
	JMP over

left    LDA #$10
	STA HMP0
	JMP over

right   LDA #$F0
	STA HMP0

over    LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

	org $FE70
; Generated by JunkoSoft Sprite Editor (Version 1.0)
ship    .byte $3C,$7E,$FF,$FF,$08,$38,$18,$08
colors  .byte $12,$12,$12,$12,$0F,$0F,$0F,$0F

	org $FFFC
	.word Start
	.word Start     

